#include "StdAfx.h"
#include ".\cmapevent.h"

CMapEvent::CMapEvent(int x, int y) {
	int i,j;

	xSize = x;
	ySize = y;
	xCenter = x / 2;
	yCenter = y / 2;

	// X * Y + 1 ̃TCYŃm
	m_lpm = (char*)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (xSize * ySize) + 1);

	for (i = 0;i < xSize;i++) {
		for (j = 0;j < ySize;j++) {
			if (rand() % 10 > 0) continue;
			// 1: 2:K 3:
			*(m_lpm + (i * ySize) + j) = (rand() % 3) + 1;
			// ɕ
			if (*(m_lpm + (i * ySize) + j) == 3) {
				*(m_lpm + (i * ySize) + j) += rand() % 3;
			}
		}
	}

}

CMapEvent::~CMapEvent(void) {
	HeapFree(GetProcessHeap(), 0, m_lpm);
}

int CMapEvent::getEvent(int x, int y) {
	return (int)*(m_lpm + (x * ySize) + y);
}

void CMapEvent::setEvent(int x, int y, int status) {
	*(m_lpm + (x * ySize) + y) = (char)status;
}